<?php
/*
Plugin Name: Post of template
Plugin URI:  http://wpdemo.dovi42.hu/html-sablonok
Description: Bejegyzés kategóriát HTML sablonként használ
Version:     1.04
Author:      Dovi42
Author URI:  http://dovi42.hu/
License:     GPLv2 or later
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: post-of-template
Generator:   WP Creator - http://wpcreator.hu - 2020-04-09 15:08:36
*/

if ( !defined( 'ABSPATH' ) ) exit;

function post_of_template_615_update()
{
    require_once ( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'autoupdate.php' ); 
	
	$plugin_current_version = '1.04'; // Current version
	$plugin_remote_path     = 'http://update.dovi42.hu/post-of-template/update.php';  
	$plugin_slug            = plugin_basename(__file__);
	$license_user           = get_site_url();
	$license_key            = '<optional license key>';

	if ( $license_user && $license_key && $plugin_remote_path )
	{
		new post_of_template_615_AutoUpdate ($plugin_current_version, $plugin_remote_path, $plugin_slug, $license_user, $license_key);
	}
}
add_action('init', 'post_of_template_615_update');

function post_of_template_615_get_options() { 
	$defaults = array(
			'category'          => '',
			'disable_in_search' => '1',
            'mode'              => 'content'
		);
	$options = get_option('post_of_template_options');
	$options = wp_parse_args($options, $defaults);

	return $options;
}

function post_of_template_615_load_textdomain() {
    load_plugin_textdomain( 'post-of-template', false, basename( dirname( __file__ )) . '/languages' ); 
}
add_action( 'plugins_loaded', 'post_of_template_615_load_textdomain' );

function post_of_template_615_notices() {
    if( get_transient( 'post_of_template_615_activation_notice' ) ) {
        echo '<div class="notice notice-success"><p>' . __('Set the category you want to use as a template! Press click <a href="options-general.php?page=post-of-template-setting-admin">here!</a>', 'post-of-template') . '</p></div>';
        delete_transient( 'post_of_template_615_activation_notice' );
    }
}
add_action( 'admin_notices', 'post_of_template_615_notices' );


function post_of_template_615_activation() {
	$options = post_of_template_615_get_options();
	update_option('post_of_template_options', $options, true);
    
    add_action( 'admin_notices', 'post_of_template_615_activation_notice' );
    set_transient( 'post_of_template_615_activation_notice', 1 );
}
register_activation_hook( __file__, 'post_of_template_615_activation' );

function post_of_template_615_uninstall() {
    delete_option('post_of_template_options');
}
register_uninstall_hook( __file__, 'post_of_template_615_uninstall' );

if ( is_admin() ){ 
    
    global $pagenow;

    include( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'post-of-template-setup.php' );
    $my_settings_page = new post_of_template_615_settings();

}

function post_of_template_615_add_settings_link( $links ) {
    $settings_link = '<a href="options-general.php?page=post-of-template-setting-admin">' . __( 'Settings' ) . '</a>';
    array_unshift( $links, $settings_link );
  	return $links;
}
$plugin = plugin_basename( __file__ );
add_filter( "plugin_action_links_$plugin", 'post_of_template_615_add_settings_link' );

function post_of_template_615_styles_and_scripts_to_backend()
{
    global $pagenow;
    
    if ( in_array( $pagenow, array( 'post.php', 'page.php', 'post-new.php', 'post-edit.php' ) ) ) {
        wp_enqueue_style('post-of-template', plugins_url( 'post-of-template/assets/css/post-of-template-admin.css' ), false, '0.0.1' );
    	wp_enqueue_style( 'post-of-template' );
        wp_register_script('post-of-template-button-js', plugins_url( 'post-of-template/assets/js/post-of-template-admin.js' ), array('jquery'), false, true);
        wp_localize_script('post-of-template-button-js', 'post_of_template_615_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
        wp_enqueue_script( 'post-of-template-button-js');
    }

    $page = '';
    if (isset($_REQUEST['page']) ) {
        $page = sanitize_text_field( $_REQUEST['page'] );
    }
    if (($pagenow == 'options-general.php') and ($page == 'post-of-template-setting-admin')) {
        wp_register_style( 'post-of-template-admin', plugins_url( 'assets/css/post-of-template-admin.css', __file__ ) );
    	wp_enqueue_style( 'post-of-template-admin' );
    }
}
add_action( 'admin_enqueue_scripts', 'post_of_template_615_styles_and_scripts_to_backend' );

function post_of_template_615_exclude_category_search( $query ) {

    if ( !is_admin() ){
        if ($query->is_home() || $query->is_main_query() || $query->is_search()) {

            $options = post_of_template_615_get_options();
            if (($options['category'] != '') and ($options['disable_in_search'] == 1)) {
    
                $cat = get_category_by_slug($options['category']);
                if ((!empty($cat)) and ($cat->cat_ID)) {
                    $query->set( 'cat', '-'.$cat->cat_ID );
                }

            }
        }
    }
}
add_action( 'pre_get_posts', 'post_of_template_615_exclude_category_search' );

function post_of_template_615_add_media_button() {
    global $pagenow;
    if ( in_array( $pagenow, array( 'post.php', 'page.php', 'post-new.php', 'post-edit.php' ) ) ) {
        $html = '<a href="javascript:void(0);" onclick="post_of_template_615_show_select_box();" id="post-of-template-insert-template" class="button">'.
                '<span class="wp-media-buttons-icon dashicons dashicons-media-code" style="margin-top:-3px;"></span>'.
                __('Insert template', 'post-of-template') . '</a>';
    }
    echo $html;
}
add_filter('media_buttons', 'post_of_template_615_add_media_button');


function post_of_template_615_admin_footer()
{
    global $pagenow;
    if ( in_array( $pagenow, array( 'post.php', 'page.php', 'post-new.php', 'post-edit.php' ) ) ) {
         $options = post_of_template_615_get_options();
         ?>
        <div id="template-select-box" style="display: none;">
            <h4><?php echo __('Templates', 'post-of-template');?></h4>
            <div class="wrap" style="text-align: left;padding:10px;margin:0;">
                <select id="post-of-template-list" style="display:inline-block;float:left;">
                    <option value=""><?php echo __('--== Please, select template! ==--', 'post-of-template');?></option>
                    <?php
                        $args = array (
                                'post_type'      => 'post',
                                'category_name'  => $options['category'],
                                'order'          => 'ASC',
                                'orderby'        => 'name',
                                'posts_per_page' => 100,
                            );
                        $posts = get_posts($args);
                        foreach ($posts as $post) {
                            echo '<option value="'.$post->post_name.'">'.$post->post_title.'</option>';
                        }
                    ?>
                </select>
                <input onclick="post_of_template_615_cancel_select();" type="button" class="button" value="<?php echo __('Cancel','post-of-template');?>" style="display:inline-block;float:right;margin-left:4px;"/>
                <button id="template_ok_button" onclick="post_of_template_615_getSelectedHTML();" type="button" class="button button-primary" disabled style="display:inline-block;float:right;margin-left:4px;"/>
                    <span class="dashicons dashicons-update" style="display:none;margin-top: 4px;"></span>
                    <span class="text"><?php echo __('Insert','post-of-template');?></span>
                </button>
                <div style="clear: both;"></div> 
                <div style="margin-top:6px;">
                    <?php 
                        $checked = '';
                        if ($options['mode'] == 'content') { $checked = ' CHECKED '; }
                    ?>
                    <input type="radio" id="template_mode_content" name="template_mode" value="content" <?php echo $checked;?> />                 
                    <label for="template_mode_content"><?php echo __('Content', 'post-of-template');?></label>                                     
                    <?php 
                        $checked = '';
                        if ($options['mode'] == 'shortcode') { $checked = ' CHECKED '; }
                    ?>
                    <input type="radio" id="template_mode_shortcode" name="template_mode" value="shortcode" <?php echo $checked;?> style="margin-left: 40px;" />
                    <label for="template_mode_shortcode"><?php echo __('Shortcode', 'post-of-template');?></label>                                     
                </div>
                <div style="clear: both;"></div> 
            </div>
        </div>
        <?php
    }
}
add_action('admin_footer', 'post_of_template_615_admin_footer', 11);

function post_of_template_615_get_template_content()
{
    $slug = '';
    if (isset($_REQUEST['slug'])) {
        $slug = sanitize_text_field($_REQUEST['slug']);
    }
    $mode = '';
    if (isset($_REQUEST['mode'])) {
        $mode = sanitize_text_field($_REQUEST['mode']);
    }

    if ((empty($slug)) or (empty($mode))) {
        $content = '<!-- ' . __('This slug or mode not set.', 'post-of-template') . ' -->';
    } else {
        if ($mode == 'shortcode') {
            $content = '[post-of-template slug="'.$slug.'"]';
        } else {
            $args = array(
                    'name'        => $slug,
                    'post_type'   => 'post',
                    'numberposts' => 1
                );
            $posts = get_posts($args);
            if (empty($posts)) {
                $content = '<!-- ' . __('This content not found.', 'post-of-template') . ' -->';
            } else {
                $content = $posts[0]->post_content;
            }
        }
    }
    $result = array(
        'status' => 1,
        'html'   => $content
    );
    echo json_encode($result);
    wp_die();

}
add_action( 'wp_ajax_nopriv_post_of_template_615_get_template_content', 'post_of_template_615_get_template_content' );
add_action( 'wp_ajax_post_of_template_615_get_template_content', 'post_of_template_615_get_template_content' );

function post_of_template_615_insert_template($args) {

    if (!isset($args['slug'])) {
        $html = '<!-- ' . __('Content slug not set.', 'post-of-template') . ' -->';
        return $html;
    }

    $sets = array(
            'name'        => $args['slug'],
            'post_type'   => 'post',
            'numberposts' => 1
        );
    $posts = get_posts($sets);
    if (empty($posts)) {
        $html = '<!-- ' . sprintf(__('This content not found. (%s)', 'post-of-template'), $args['slug']) . ' -->';
    } else {
        $html = $posts[0]->post_content;
    }
    
    return $html;
}
add_shortcode('post-of-template', 'post_of_template_615_insert_template');


